//------------------------------------------------------------
//    tmajan
//------------------------------------------------------------
#include "tmajan.h"
#include <boost/random.hpp>
#include <time.h>

//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
tMajan::tMajan()
{
	pai_init();
	seki_1 = new Seki();
	playing = false;
	tumo_flg = false;
}

//------------------------------------------------------------
//    destructor
//------------------------------------------------------------
tMajan::~tMajan()
{
	
}


//------------------------------------------------------------
//    tMajan::play_init()
//------------------------------------------------------------
void tMajan::play_init()
{
	int i1, pa0[13];
	for(i1 = 0; i1 < 34; i1++){
		yama[i1*4  ] = i1;
		yama[i1*4+1] = i1;
		yama[i1*4+2] = i1;
		yama[i1*4+3] = i1;
	}
	shuffle(shuffle_times);
	for(i1 = 0; i1 < 13; i1++){
		pa0[i1] = yama[i1];
	}
	seki_1->set_haipai(pa0);
	seki_1->set_tumo_hai(yama[13]);
	tumo_flg = true;
	playing = true;
	seki_1->set_reach(-1);
}


//------------------------------------------------------------
//    pai_init
//------------------------------------------------------------
void tMajan::pai_init()
{
	int n1, i1;
	std::string filename;
	
	n1 = 0;
	for(i1 = 1; i1 <= 9; i1++){
		Pais[n1].set_paisuit(manz);
		Pais[n1].set_number(n1);
		Pais[n1].set_pt_num(i1);
		n1++;
	}
	Pais[0].set_name("man1");
	Pais[1].set_name("man2");
	Pais[2].set_name("man3");
	Pais[3].set_name("man4");
	Pais[4].set_name("man5");
	Pais[5].set_name("man6");
	Pais[6].set_name("man7");
	Pais[7].set_name("man8");
	Pais[8].set_name("man9");
	
	for(i1 = 1; i1 <= 9; i1++){
		Pais[n1].set_paisuit(pinz);
		Pais[n1].set_number(n1);
		Pais[n1].set_pt_num(i1);
		n1++;
	}
	Pais[9].set_name("pin1");
	Pais[10].set_name("pin2");
	Pais[11].set_name("pin3");
	Pais[12].set_name("pin4");
	Pais[13].set_name("pin5");
	Pais[14].set_name("pin6");
	Pais[15].set_name("pin7");
	Pais[16].set_name("pin8");
	Pais[17].set_name("pin9");
	
	for(i1 = 1; i1 <= 9; i1++){
		Pais[n1].set_paisuit(souz);
		Pais[n1].set_number(n1);
		Pais[n1].set_pt_num(i1);
		n1++;
	}
	Pais[18].set_name("sou1");
	Pais[19].set_name("sou2");
	Pais[20].set_name("sou3");
	Pais[21].set_name("sou4");
	Pais[22].set_name("sou5");
	Pais[23].set_name("sou6");
	Pais[24].set_name("sou7");
	Pais[25].set_name("sou8");
	Pais[26].set_name("sou9");
	
	for(i1 = 1; i1 <= 7; i1++){
		Pais[n1].set_paisuit(jihai);
		Pais[n1].set_number(n1);
		Pais[n1].set_pt_num(i1);
		n1++;
	}
	Pais[27].set_name("ton");
	Pais[28].set_name("nan");
	Pais[29].set_name("sha");
	Pais[30].set_name("pei");
	Pais[31].set_name("haku");
	Pais[32].set_name("hatu");
	Pais[33].set_name("tyun");
}

//------------------------------------------------------------
//    shuffle
//------------------------------------------------------------
void tMajan::shuffle(int times)
{
	int i1, n1, n2, pi1, bufa[yama_counts];
	boost::mt19937 gen( static_cast<unsigned long>(time(0)) );
	boost::uniform_int<> dst(0, 135);
	boost::variate_generator<boost::mt19937, boost::uniform_int<> >
		rand(gen, dst);
	
	for(i1 = 0; i1 < 136; i1++){
		bufa[i1] = yama[i1];
	}
	
	for(i1 = 0; i1 < times; i1++){
		n1 = rand();
		n2 = rand();
		pi1 = bufa[n1];
		bufa[n1] = bufa[n2];
		bufa[n2] = pi1;
	}
	
	for(i1 = 0; i1 < 136; i1++){
		yama[i1] = bufa[i1];
	}
}

//------------------------------------------------------------
//    int tMajan::get_yama_hai(int p)
//------------------------------------------------------------
int tMajan::get_yama_hai(int p)
{
	if(p<136){
		return(yama[p]);
	}else{
		return(-1);
	}
}

//------------------------------------------------------------
//    void tMajan::get_yama(int *p)
//------------------------------------------------------------
void tMajan::get_yama(int *p)
{
	int i1;
	for(i1 = 0; i1 < 22; i1++){
		p[i1] = yama[i1];
	}
}

